<template>
  <header class="overflow-hidden">
    <nav class="absolute top-0 left-0 z-10 w-full bg-transparent">
      <div class="container">
        <div class="relative flex items-center justify-between h-20">
          <div class="absolute inset-y-0 right-0 flex items-center sm:hidden">
            <!-- Mobile menu button-->
            <button
              type="button"
              class="inline-flex items-center justify-center p-2 text-white rounded-md hover:text-secondary hover:bg-primary focus:outline-none focus:ring-2 focus:ring-inset focus:ring-primary"
              aria-controls="mobile-menu"
              aria-expanded="false"
              @click.prevent="offcanvasToggle = !offcanvasToggle"
            >
              <span class="sr-only">Open main menu</span>

              <svg
                v-if="!offcanvasToggle"
                class="block w-6 h-6"
                xmlns="http://www.w3.org/2000/svg"
                fill="none"
                viewBox="0 0 24 24"
                stroke-width="2"
                stroke="currentColor"
                aria-hidden="true"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  d="M4 6h16M4 12h16M4 18h16"
                />
              </svg>

              <svg
                v-if="offcanvasToggle"
                class="block w-6 h-6"
                xmlns="http://www.w3.org/2000/svg"
                fill="none"
                viewBox="0 0 24 24"
                stroke-width="2"
                stroke="currentColor"
                aria-hidden="true"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  d="M6 18L18 6M6 6l12 12"
                />
              </svg>
            </button>
          </div>

          <div class="flex items-center justify-start flex-1 sm:items-stretch">
            <div class="flex items-center flex-shrink-0">
              <!-- <a :href="$router.push(localeLocation({ name: 'index' }))">
                <BrandLogo class="block w-auto h-12" />
              </a> -->
              <nuxt-link :to="localePath('/')">
                <BrandLogo class="block w-auto h-12" />
              </nuxt-link>
            </div>
          </div>

          <div
            class="absolute inset-y-0 right-0 flex items-center pr-2 sm:static sm:inset-auto sm:ml-6 sm:pr-0"
          >
            <div class="hidden sm:block sm:ml-6">
              <div class="relative flex space-x-4 main-menu">
                <client-only v-for="(item, index) in fullMenu" :key="index">
                  <div class="relative">
                    <a
                      class="relative px-3 py-2 text-sm font-medium text-white uppercase rounded-md cursor-pointer bai hover:text-primary"
                      :class="[
                        {
                          active:
                            $i18n.locale !== 'es' && item.path !== '/'
                              ? $route.path === `/${$i18n.locale}${item.path}`
                              : $route.path === item.path,
                        },
                        {
                          active:
                            $i18n.locale !== 'es' && item.path === '/'
                              ? $route.path === `/${$i18n.locale}`
                              : false,
                        },
                        {
                          active: $route.path.includes(item.path) && item.path !== '/'
                            ? true
                            : false,
                        },
                      ]"
                      @click.prevent="menuAction(index, null, 0, item)"
                      >{{ item.name }}
                    </a>

                    <transition
                      v-if="item.state && item.subItems.length > 0"
                      enter-active-class="transition duration-100 ease-out"
                      enter-from-class="transform scale-95 opacity-0"
                      enter-to-class="transform scale-100 opacity-100"
                      leave-active-class="transition duration-75 ease-in"
                      leave-from-class="transform scale-100 opacity-100"
                      leave-to-class="transform scale-95 opacity-0"
                    >
                      <div
                        class="absolute left-1/2 transform -translate-x-1/2 w-auto min-w-[100%] mt-5 origin-center bg-transparent"
                        role="menu"
                        aria-orientation="vertical"
                        aria-labelledby="menu-button"
                        tabindex="-1"
                      >
                        <div
                          class="relative py-0 space-y-0 text-center"
                          role="none"
                        >
                          <client-only
                            v-for="(subitem, subindex) in item.subItems"
                            :key="subindex"
                          >
                            <div class="relative">
                              <a
                                class="relative bai block py-2 px-2 text-sm font-medium text-white bg-[#2A3640] uppercase cursor-pointer hover:text-primary"
                                :class="[
                                  {
                                    'text-primary':
                                      $route.path === subitem.path,
                                  },
                                  {
                                    'text-primary':
                                      currentRoutePath.split('/')[2] ===
                                      subitem.path
                                        .replace(item.path, '')
                                        .replace('/', ''),
                                  },
                                ]"
                                @click.prevent="
                                  menuAction(subindex, index, 1, subitem)
                                "
                              >
                                {{ subitem.name }}
                              </a>

                              <transition
                                v-if="
                                  subitem.state && subitem.subItems.length > 0
                                "
                                enter-active-class="transition duration-100 ease-out"
                                enter-from-class="transform scale-95 opacity-0"
                                enter-to-class="transform scale-100 opacity-100"
                                leave-active-class="transition duration-75 ease-in"
                                leave-from-class="transform scale-100 opacity-100"
                                leave-to-class="transform scale-95 opacity-0"
                              >
                                <div
                                  class="absolute left-full top-0 w-auto min-w-[100%] ml-0 origin-top-right bg-primary"
                                  role="menu"
                                  aria-orientation="vertical"
                                  aria-labelledby="menu-button"
                                  tabindex="-1"
                                >
                                  <div
                                    class="relative py-0 space-y-0 text-center"
                                    role="none"
                                  >
                                    <a
                                      v-for="(
                                        thritem, thriindex
                                      ) in subitem.subItems"
                                      :key="thriindex"
                                      class="relative block px-2 py-2 text-sm font-medium uppercase transition-all duration-300 ease-in-out cursor-pointer bai text-secondary hover:bg-white hover:text-secondary"
                                      :class="[
                                        {
                                          'text-secondary bg-white':
                                            $route.path === thritem.path,
                                        },
                                      ]"
                                      @click.prevent="
                                        menuAction(thriindex, index, 2, thritem)
                                      "
                                    >
                                      {{ thritem.name }}
                                    </a>
                                  </div>
                                </div>
                              </transition>
                            </div>
                          </client-only>
                        </div>
                      </div>
                    </transition>
                  </div>
                </client-only>

                <LangSwitcher class="-mt-1" />
              </div>
            </div>
          </div>
        </div>
      </div>

      <!-- Mobile menu, show/hide based on menu state. -->
      <transition
        v-if="offcanvasToggle"
        enter-active-class="transition duration-100 ease-out"
        enter-from-class="transform scale-95 opacity-0"
        enter-to-class="transform scale-100 opacity-100"
        leave-active-class="transition duration-75 ease-in"
        leave-from-class="transform scale-100 opacity-100"
        leave-to-class="transform scale-95 opacity-0"
      >
        <div
          class="bg-transparent sm:hidden bg-primary h-[calc(100vh-80px)]"
          id="mobile-menu"
        >
          <div class="text-center uppercase">
            <client-only v-for="(item, index) in fullMenu" :key="index">
              <a
                class="relative block px-3 py-3 text-lg font-semibold text-secondary bg-primary bai"
                :class="[
                  {
                    active:
                      $i18n.locale !== 'es' && item.path !== '/'
                        ? $route.path === `/${$i18n.locale}${item.path}`
                        : $route.path === item.path,
                  },
                  {
                    active:
                      $i18n.locale !== 'es' && item.path === '/'
                        ? $route.path === `/${$i18n.locale}`
                        : false,
                  },
                ]"
                @click.prevent="menuAction(index, null, 0, item)"
              >
                {{ item.name }}

                <svg
                  v-if="item.subItems.length > 0"
                  xmlns="http://www.w3.org/2000/svg"
                  class="absolute w-6 h-6 text-white transform rotate-0 -translate-y-1/2 right-3 top-1/2"
                  :class="[
                    {
                      '-rotate-90': item.state && item.subItems.length > 0,
                    },
                  ]"
                  fill="none"
                  viewBox="0 0 24 24"
                  stroke="currentColor"
                  stroke-width="2"
                >
                  <path
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    d="M15 19l-7-7 7-7"
                  />
                </svg>
              </a>

              <transition
                v-if="item.state && item.subItems.length > 0"
                enter-active-class="transition duration-100 ease-out"
                enter-from-class="transform scale-95 opacity-0"
                enter-to-class="transform scale-100 opacity-100"
                leave-active-class="transition duration-75 ease-in"
                leave-from-class="transform scale-100 opacity-100"
                leave-to-class="transform scale-95 opacity-0"
              >
                <div
                  class="w-full origin-center bg-secondary"
                  role="menu"
                  aria-orientation="vertical"
                  aria-labelledby="menu-button"
                  tabindex="-1"
                >
                  <div class="relative text-center" role="none">
                    <client-only
                      v-for="(subitem, subindex) in item.subItems"
                      :key="subindex"
                    >
                      <div class="relative">
                        <a
                          class="relative block p-3 text-lg font-semibold text-white uppercase cursor-pointer bai"
                          :class="[
                            { 'text-primary': $route.path === subitem.path },
                            {
                              'text-primary':
                                currentRoutePath.split('/')[2] ===
                                subitem.path
                                  .replace(item.path, '')
                                  .replace('/', ''),
                            },
                          ]"
                          @click.prevent="
                            menuAction(subindex, index, 1, subitem)
                          "
                        >
                          {{ subitem.name }}

                          <svg
                            v-if="subitem.subItems.length > 0"
                            xmlns="http://www.w3.org/2000/svg"
                            class="absolute w-6 h-6 text-white transform rotate-0 -translate-y-1/2 right-3 top-1/2"
                            :class="[
                              {
                                '-rotate-90':
                                  subitem.state && subitem.subItems.length > 0,
                              },
                            ]"
                            fill="none"
                            viewBox="0 0 24 24"
                            stroke="currentColor"
                            stroke-width="2"
                          >
                            <path
                              stroke-linecap="round"
                              stroke-linejoin="round"
                              d="M15 19l-7-7 7-7"
                            />
                          </svg>
                        </a>

                        <transition
                          v-if="subitem.state && subitem.subItems.length > 0"
                          enter-active-class="transition duration-100 ease-out"
                          enter-from-class="transform scale-95 opacity-0"
                          enter-to-class="transform scale-100 opacity-100"
                          leave-active-class="transition duration-75 ease-in"
                          leave-from-class="transform scale-100 opacity-100"
                          leave-to-class="transform scale-95 opacity-0"
                        >
                          <div
                            class="w-auto min-w-[100%] origin-top-right bg-tertiary"
                            role="menu"
                            aria-orientation="vertical"
                            aria-labelledby="menu-button"
                            tabindex="-1"
                          >
                            <div class="relative text-center" role="none">
                              <a
                                v-for="(thritem, thriindex) in subitem.subItems"
                                :key="thriindex"
                                class="relative block p-3 text-lg font-semibold text-white uppercase transition-all duration-300 ease-in-out cursor-pointer bai"
                                :class="[
                                  {
                                    'text-secondary bg-white':
                                      $route.path === thritem.path,
                                  },
                                ]"
                                @click.prevent="
                                  menuAction(thriindex, index, 2, thritem)
                                "
                              >
                                {{ thritem.name }}
                              </a>
                            </div>
                          </div>
                        </transition>
                      </div>
                    </client-only>
                  </div>
                </div>
              </transition>
            </client-only>
          </div>
        </div>
      </transition>
    </nav>
  </header>
</template>

<script>
export default {
  name: 'HeaderComponent',

  data() {
    return {
      offcanvasToggle: false,
      // menu: [
      //   { name: 'Inicio', path: '/' },
      //   { name: 'Cree', path: '/cree' },
      //   { name: 'Aprende', path: '/aprende' },
      //   { name: 'Mina', path: '/mina' },
      //   { name: 'FAQS', path: '/faqs' },
      //   { name: 'Nosotros', path: '/nosotros' },
      //   { name: 'Contacto', path: '/contacto' },
      // ],
      currentLvl0: null,
      currentLvl1: null,
    }
  },

  computed: {
    currentRoutePath() {
      // console.log(this.$route, 'route')
      return this.$route.path
    },
    fullMenu() {
      return this.$t('fullMenu')
      // return this.menu
    },
  },

  methods: {
    menuAction(index, parent, deep, item) {
      if (item.type !== 'void') {
        if (item.type === 'external') {
          window.open(item.url)
        } else {
          this.$router.push(this.localePath({ path: item.path }))

          if (this.currentLvl0) {
            this.fullMenu[this.currentLvl0.index].state =
              !this.fullMenu[this.currentLvl0.index].state
            this.currentLvl0 = null
          }
          if (this.currentLvl1) {
            this.fullMenu[this.currentLvl1.index].state =
              !this.fullMenu[this.currentLvl1.index].state
            this.currentLvl1 = null
          }
        }

        this.offcanvasToggle = false
      } else {
        this.openMenu(index, parent, deep)
      }
    },

    openMenu(index, parent, deep) {
      const currentSetup = { index, parent, deep }
      const compareDeep0 =
        JSON.stringify(this.currentLvl0) === JSON.stringify(currentSetup)
      const compareDeep1 =
        JSON.stringify(this.currentLvl1) === JSON.stringify(currentSetup)

      if (deep === 0) {
        if (this.currentLvl0) {
          if (!compareDeep0) {
            this.fullMenu[this.currentLvl0.index].state = false
            this.fullMenu[index].state = true

            if (this.currentLvl1) {
              this.fullMenu[this.currentLvl0.index].subItems[
                this.currentLvl1.index
              ].state = false
              this.currentLvl1 = null
            }

            this.currentLvl0 = currentSetup
          }

          if (compareDeep0) {
            this.fullMenu[index].state = false
            this.currentLvl0 = null
          }
        } else {
          this.fullMenu[index].state = true
          this.currentLvl0 = currentSetup
        }
      }

      if (deep === 1) {
        if (this.currentLvl1) {
          if (!compareDeep1) {
            this.fullMenu[this.currentLvl0.index].subItems[
              this.currentLvl1.index
            ].state = false
            this.fullMenu[this.currentLvl0.index].subItems[index].state = true
            this.currentLvl1 = currentSetup
          }

          if (compareDeep1) {
            this.fullMenu[this.currentLvl0.index].subItems[index].state = false
            this.currentLvl1 = null
          }
        } else {
          this.fullMenu[this.currentLvl0.index].subItems[index].state = true
          this.currentLvl1 = currentSetup
        }
      }
    },
  },
}
</script>
